# -*- coding: utf-8 -*-
# !/usr/bin/env python3
# VERSION: 1.6
# AUTHORS: HuangYeWuDeng
import json
try:
    from urllib.parse import urlencode, unquote, quote_plus
    # from html.parser import HTMLParser
except ImportError:
    from urllib import urlencode, unquote, quote_plus
    # from HTMLParser import HTMLParser

# local
from novaprinter import prettyPrinter
from helpers import retrieve_url

class cilimao(object):
    url = 'http://rom.nanodm.net/N1/qb/cilimao.py'
    name = 'cilimao'
    supported_categories = {'all': '', 'movies': 1, 'music': 2, 'pictures': 3, 'books': 4, 'software': 6}
    limit = 10

    def search(self, keyword, cat='all'):
        api_url = 'https://www.cilimao.one/api/search?size=10&sortDirections=desc&word={}&resourceSource=0&page={}'
        if cat != 'all':
            api_url += "&resourceType={}".format(self.supported_categories[cat])

        job = score()
        for page in range(0, 10):
            try:
                url = api_url.format(quote_plus(keyword), page)
                # print url
                data = retrieve_url(url)
                j = json.loads(data, encoding='utf-8')
                # with open("tmp.json", "w") as f:
                #     json.dump(j, f)
                if 'ok' == j['status'] and 'result' in j['data'] and 'content' in j['data']['result']:
                    for torrent in j['data']['result']['content']:
                        try:
                            # print torrent['title'].encode('latin-1').decode('utf-8')
                            if torrent != 'ad':
                                res = {'link': job.magnetBuilder(torrent['infohash'], torrent['title']),
                                       'name': torrent['title'],
                                       'size': '{}'.format(torrent['content_size']),
                                       'seeds': -1,
                                       'leech': -1,
                                       'engine_url': '[{engine}], created time:{created_time} ， file count:{file_count}'.
                                           format(engine=self.name, created_time=torrent['created_time'], file_count=torrent['file_count']),
                                       'desc_link': "https://www.cilimao.cc/information/{}".format(torrent['infohash'])}
                                job.done(res)
                        except Exception:
                            pass
                    total_pages = int(j['data']['result']['total_pages'])
                    cur_page = int(j['data']['result']['number'])
                    if cur_page + 1 >= total_pages:
                        break
                else:
                    # NOTE: not supported browsing
                    job.done()
            except Exception:
                pass

class score(object):
    supported_browse_params = {'browse':'browse-movies','query_term':'0', 'quality':'all','genre':'all','minimum_rating':'0','sort_by':'latest'}

    tracker = [
        'udp://62.138.0.158:6969/announce',
        'udp://188.241.58.209:6969/announce',
        'udp://188.241.58.209:6969/announce',
        'udp://185.225.17.100:1337/announce',
        'http://62.210.79.110:1337/announce',
        'udp://151.80.120.114:2710/announce',
        'udp://151.80.120.114:2710/announce',
        'udp://208.83.20.20:6969/announce',
        'udp://184.105.151.164:6969/announce',
        'udp://176.113.68.67:8080/announce',
        'http://176.113.71.19:6961/announce',
        'udp://176.113.68.66:6961/announce',
        'udp://51.15.40.114:80/announce',
        'udp://5.2.79.219:1337/announce',
        'udp://5.2.79.22:6969/announce',
        'udp://89.234.156.205:451/announce',
        'udp://5.206.58.23:6969/announce',
        'udp://176.31.106.35:80/announce',
        'udp://188.246.227.212:80/announce',
        'http://95.107.48.115:80/announce']

    def magnetBuilder(self,hash, name):
        return "magnet:?xt=urn:btih:{}&{}&{}".format(hash, urlencode({'dn': name}), '&'.join(map(lambda x: 'tr='+quote_plus(x.strip()), self.tracker)))

    def done(self,res={}):
        if res:
            # print(res['name'])
            prettyPrinter(res)
        else:
            """ None """

if __name__=="__main__":
    """ debug """